﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace OfficeShadowDisabler
{
    public class SystemProcessHookForm : Form
    {
        private readonly int msgNotify;
        public delegate void EventHandler(object sender, ShellHook.ShellEvents action, IntPtr hWnd, string windowTitle);
        public event EventHandler WindowEvent;
        protected virtual void OnWindowEvent(ShellHook.ShellEvents action, IntPtr hWnd, string windowTitle)
        {
            var handler = WindowEvent;
            if (handler != null)
            {
                handler(this, action, hWnd, windowTitle);
            }
        }

        public SystemProcessHookForm()
        {
            // Hook on to the shell
            msgNotify = ShellHook.RegisterWindowMessage("SHELLHOOK");
            ShellHook.RegisterShellHookWindow(this.Handle);
        }

        protected override void WndProc(ref Message m)
        {
            if (m.Msg == msgNotify)
            {
                // Receive shell messages
                switch ((ShellHook.ShellEvents)m.WParam.ToInt32())
                {
                    case ShellHook.ShellEvents.HSHELL_WINDOWCREATED:
                    case ShellHook.ShellEvents.HSHELL_WINDOWACTIVATED:
                        string wName = GetWindowName(m.LParam);
                        var action = (ShellHook.ShellEvents)m.WParam.ToInt32();
                        OnWindowEvent(action, m.LParam, wName);
                        break;
                }
            }
            base.WndProc(ref m);
        }


        private string GetWindowName(IntPtr hwnd)
        {
            StringBuilder sb = new StringBuilder();
            int longi = ShellHook.GetWindowTextLength(hwnd) + 1;
            sb.Capacity = longi;
            ShellHook.GetWindowText(hwnd, sb, sb.Capacity);
            return sb.ToString();
        }

        protected override void Dispose(bool disposing)
        {
            try { ShellHook.DeregisterShellHookWindow(this.Handle); }
            catch { }
            base.Dispose(disposing);
        }

        private void InitializeComponent()
        {
            this.SuspendLayout();
            // 
            // SystemProcessHookForm
            // 
            this.Name = "SystemProcessHookForm";
            this.ResumeLayout(false);

        }
    }
}
